//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdlib.h>
#include <stdio.h>
#include <tchar.h>
#pragma hdrstop

#include "_change_num.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

TForm1 *Form1;
HANDLE hD;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
// DiskSector WinNT
//
bool DiskOpen(char *vol)
{
  char szDrive[10];
  sprintf(szDrive, "\\\\.\\%c:", vol[0]);
  hD = CreateFile(
    szDrive,
    GENERIC_READ | GENERIC_WRITE,
    FILE_SHARE_READ | FILE_SHARE_WRITE,
    NULL,
    OPEN_EXISTING, 
    0, 
    NULL);
  return hD != INVALID_HANDLE_VALUE;
}

void DiskClose()
{
  if (hD != INVALID_HANDLE_VALUE)
    CloseHandle(hD);
}

bool ReadSector (DWORD sector, char *Buffer, int sectorSize)
{
  DWORD read = 0;

  if (SetFilePointer(hD, sector, NULL, FILE_BEGIN) == INVALID_SET_FILE_POINTER)
    return false;

  if (!ReadFile(hD, Buffer, sectorSize, &read, NULL))
    return false;
  return true;
}

bool WriteSector(DWORD sector, char *Buffer, int sectorSize)
{
  DWORD wrote = 0;
  
  if (SetFilePointer(hD, sector, NULL, FILE_BEGIN) == INVALID_SET_FILE_POINTER)
    return false;

  if (!WriteFile(hD, Buffer, sectorSize, &wrote, NULL))
    return false;

  return true;
}


//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  if ((ComboBox1->Text !="") && (Edit1->Text !=""))
  {
    DWORD newSerial = StrToInt(Edit1->Text);
    const max_pbsi = 3;

    struct partial_boot_sector_info
    {
      LPSTR Fs; //   
      DWORD FsOffs; //      
      DWORD SerialOffs; //      
    };

    partial_boot_sector_info pbsi[max_pbsi] =
    {
     {"FAT32", 0x52, 0x43},
     {"FAT",   0x36, 0x27},
     {"NTFS",  0x03, 0x48}
    };

    TCHAR Drive[12]={0};
    char Sector[512];
    DWORD i;
    sprintf(Drive, "%s:\\", ComboBox1->Text);

    if (!DiskOpen(Drive))
    {
      Application->MessageBoxA("  !","");
      return;
    }

  //   
    if (!ReadSector(0, Sector,512))
    {
      Application->MessageBoxA("  ","");
      return;
    }

  //    
    for (i=0;i<max_pbsi;i++)
    {
      //  
      if (strncmp(pbsi[i].Fs, Sector+pbsi[i].FsOffs, strlen(pbsi[i].Fs)) == 0)
      {
        break;
      }
    }

    if (i >= max_pbsi)
    {
      Application->MessageBoxA("        !","");
      return;
    }

  //  
    *(PDWORD)(Sector+pbsi[i].SerialOffs) = newSerial;

  //    
    if (!WriteSector(0, Sector,512))
    {
      Application->MessageBoxA("   ","");
      return;
    }
    DiskClose();
    Application->MessageBoxA("   !   ","");
  }else
     Application->MessageBoxA("     !","");
}
//---------------------------------------------------------------------------
